Player = Class{}

require 'Obstacle'

function Player:init()
    self.x = 100
    self.y = 200

    self.width = 26
    self.height = 28

    self.health = 50

    self.dx = 0
    self.dy = 0

    
    self.texture = love.graphics.newImage('graphics/ship.png')

end

function Player:update(dt)

    --calculate border collisions
    if self.x <= 0 then
        self.x = 0
    elseif self.x >= VIRTUAL_WIDTH - 28 then
        self.x = VIRTUAL_WIDTH - 28
    end

    if self.y <= 0 then
        self.y = 0
    elseif self.y >= VIRTUAL_HEIGHT - 26 then
        self.y = VIRTUAL_HEIGHT - 26
    end

    --obstacle collisions
    if self.x == obstacle.x then
        self.x = obstacle.x
    elseif self.x == obstacle.x + 4 then
        self.x = obstacle.x + 4
    end

    if self.y == obstacle.y then
        self.y = obstacle.y
    elseif self.y == obstacle.y + 4 then
        self.y = obstacle.y + 4
    end


    --update player x and y locations
    self.x = self.x + self.dx 
    self.y = self.y + self.dy 
end

function Player:render()
    scaleX = 0.08
    love.graphics.draw(self.texture, self.x, self.y, 0)
end

function Player:dmgRender()
    self.texture = love.graphics.newImage('graphics/bigShip.png')
    love.graphics.draw(self.texture, self.x, self.y, 0, scaleX)
end

function Player:reset()

    self.x = 100
    self.y = 200

    self.width = 26
    self.height = 28

    self.health = 2

    self.dx = 0
    self.dy = 0

    
    self.texture = love.graphics.newImage('graphics/ship.png')
end