Class = require 'class'
push = require 'push'

require 'Player'
require 'Obstacle'

--retro resolution
VIRTUAL_WIDTH = 233
VIRTUAL_HEIGHT = 266

--real resolution of window 
WINDOW_WIDTH = 700
WINDOW_HEIGHT = 800

PLAYER_SPEED = 1

gameState = 'start'

score = 0

--seed RNG for random behaviour
math.randomseed(os.time())

love.graphics.setDefaultFilter('nearest', 'nearest')

function love.load()
    love.window.setTitle("Dodger")
    smallFont = love.graphics.newFont('fonts/font.ttf', 8)
    mediumFont = love.graphics.newFont('fonts/font.ttf', 32)
    love.graphics.setFont(smallFont)
    
    push:setupScreen(VIRTUAL_WIDTH, VIRTUAL_HEIGHT, WINDOW_WIDTH, WINDOW_HEIGHT, {
        fullscreen = false,
        vsync = true,
        resizable = false
    })


    player = Player()
    obstacle1 = Obstacle()
    obstacle2 = Obstacle()

end

function love.keypressed(key)
    if key == 'escape' then
        love.event.quit()
    elseif key == 'enter' or key == 'return' then
        gameState = 'play'
    end
end

function love.update(dt)

    --controls
    if love.keyboard.isDown('a') then
        player.dx = -PLAYER_SPEED
    elseif love.keyboard.isDown('d') then
        player.dx = PLAYER_SPEED
    else
        player.dx = 0
    end

    if love.keyboard.isDown('w') then
        player.dy = -PLAYER_SPEED
    elseif love.keyboard.isDown('s') then
        player.dy = PLAYER_SPEED
    else
        player.dy = 0
    end

    --obstacle dmg
    if obstacle1:collision(player) then
        player:dmgRender()
        player.health = player.health - 1
    end

    if obstacle2:collision(player) then
        player:dmgRender()
        player.health = player.health - 1
    end

    --end game if health is depleted
    if player.health == 0 then
        gameState = 'end'
    end

    player:update(dt)
    obstacle1:update(dt)
    --obstacle2:update(dt)

end

function love.draw()
    push:apply('start')
    love.graphics.clear(0, 0, 0, 1)
    if gameState == 'start' then
        love.graphics.setFont(smallFont)
        love.graphics.printf("Welcome to Dodger! Press Enter to begin!", 50, 67, 133, 'center')
    elseif gameState == 'play' then
        love.graphics.setFont(smallFont)
        love.graphics.printf("Score: " .. tostring(math.floor(score * 10)), 10, 10, 100, 'left')
        if player.health < 49 then
            player:dmgRender()
        else
            player:render()
        end
        obstacle1:render()
        --obstacle2:render()
        obstacle2.dy = OBSTACLE_GRAVITY
        obstacle1.dy = OBSTACLE_GRAVITY
        score = score + 0.05

    elseif gameState == 'end' then
        love.graphics.setFont(mediumFont)
        love.graphics.printf("GAME OVER", 50, 67, 133, 'center')
        love.graphics.setFont(smallFont)
        love.graphics.printf("Score: " .. tostring(math.floor(score * 10)), 50, 200, 133, 'center')
        love.graphics.printf("Press Enter to play again!", 10, 10, 200, 'center')
        player:reset()
        player.health = 50
    end
    push:apply('end')
end